import 'package:flutter/material.dart';
import 'package:navigine_api/navigine_api.dart';

class SubLocationWidget extends StatefulWidget {
  final SubLocation subLocation;
  final Function(Offset) onTap;
  SubLocationWidget(this.subLocation, {this.onTap});
  @override
  _SubLocationWidgetState createState() => _SubLocationWidgetState();
}

class _SubLocationWidgetState extends State<SubLocationWidget> {
  SubLocation subLocation;
  @override
  void initState() {
    super.initState();
    subLocation = widget.subLocation;
  }

  @override
  void didUpdateWidget(SubLocationWidget oldWidget) {
    super.didUpdateWidget(oldWidget);
    setState(() {
      subLocation = widget.subLocation;
    });
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTapDown: (detail) {
        RenderBox getBox = context.findRenderObject();
        var local = getBox.globalToLocal(detail.globalPosition);
        widget.onTap(
          Offset(
            local.dx / getBox.size.width,
            1 - local.dy / getBox.size.height,
          ),
        );
      },
      child: Image.network(subLocation.imageFile ?? ""),
    );
  }
}
